/*
 * FittingFunction.java
 *
 * Created on July 14, 2004, 1:38 PM
 */

import org.nfunk.jep.*;

/**
 *
 * @author  gstanghe
 */
public class FittingFunction {
    JEP myParser;
    String function = "0";
    String f;
    
    /** Creates a new instance of FittingFunction */
    public FittingFunction() 
    {
    }
    
    double evaluate(double x, Parameters p)
    {
        /* Uncomment and set the following line to achieve full speed as the expression is hardcoded.
         */
        //if(true) return p.param[0].double_value * Math.exp(-p.param[1].double_value * x) + p.param[2].double_value;
        
        if(!function.equals(f))
        {
            myParser = new JEP();
            myParser.addStandardFunctions();
            myParser.addStandardConstants(); 
            for(int i = 0; i < p.ps.num_params; i++)
            {
                myParser.addVariable("a" + i, 0);
            }
            myParser.addVariable("x", 0);
            f = function;
            myParser.parseExpression(f);
        }
        
        for(int i = 0; i < p.ps.num_params; i++)
        {
            myParser.addVariable("a" + i, p.param[i].double_value);
        }
        myParser.addVariable("x", x);
        double result = myParser.getValue();
        return myParser.getValue();
    }
}
